/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.8a Standard
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : PPE DESIGN
Version : 1
Date    : 23/04/2011
Author  : Philippe Mariano
Company : Lyce Pierre Emile Martin
Comments: 
Rception d'une trame IBM pour la commande
de l'clairage et du son sur le robot suiveur de
ligne. Emission d'une trame SOMO14-D.


Chip type               : ATtiny861
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 128
*****************************************************/

#include <tiny861.h>

//===================================================================================================================== 
// Bibliothques non gnres par Wizard ( rajouter manuellement)
//---------------------------------------------------------------------------------------------------------------------   
#include <math.h>
#include <delay.h>
//---------------------------------------------------------------------------------------------------------------------
// Ces fichiers d'en-tte et les bibliothques associes doivent tre placs dans le rpertoire du projet
//---------------------------------------------------------------------------------------------------------------------
#include "TrameIBM.h"       // Sous-programme de dsrialisation et de dcodage de la
			                // trame issue de la carte SISI   
#include "SOMO14D.h"        // Contient les fonctions permettant de commander le module SOMO14D
//=====================================================================================================================

//=====================================================================================================================
// Dfinitions
//---------------------------------------------------------------------------------------------------------------------
// Boolens
//---------------------------------------------------------------------------------------------------------------------
#define VRAI                1
#define FAUX                0
//---------------------------------------------------------------------------------------------------------------------
// Timers
//---------------------------------------------------------------------------------------------------------------------
#define PWMProjecteur       OCR1B
#define PWMRuban            OCR1A
#define PWMDome             OCR1D
//---------------------------------------------------------------------------------------------------------------------
// Sortie TOR
//---------------------------------------------------------------------------------------------------------------------
#define TORLED              PORTB.0
//---------------------------------------------------------------------------------------------------------------------
// Dclaration pour le module SOMO14-D
//---------------------------------------------------------------------------------------------------------------------
#define VolumeINIT          7           // Valeur initiale de l'incrment du volume (0  7)
//=====================================================================================================================
                            
//=====================================================================================================================
// Declare your global variables here   
//---------------------------------------------------------------------------------------------------------------------
// type 		    nom 				       		dsignation   
//---------------------------------------------------------------------------------------------------------------------
/* Communication avec le clavier PS2
//---------------------------------------------------------------------------------------------------------------------
Le programme principal se synchronise avec la routine d'interruption ext_int0_isr(void) situe dans la bibliothque 
"TrameIBM.lib" grce aux variables ci-dessous (voir le fichier d'en-tte TrameIBM.h)
---------------------------------------------------------------------------------------------------------------------*/ 
unsigned char g_Code_IBM = 0;           // Caractre extrait de la trame transmise par le clavier 

bit g_flag_char = FAUX;			        // g_flag_char = 1 lorsqu'une touche est appuye
					                    // g_flag_char = 0 lorsqu'une touche a t relche 
unsigned int g_Trame_TX;                // Contient la valeur  envoyer au clavier
//=====================================================================================================================

//=====================================================================================================================
//=====================================================================================================================
// Programme principal
//---------------------------------------------------------------------------------------------------------------------
void main(void)
{
// Declare your local variables here
//---------------------------------------------------------------------------------------------------------------------
unsigned char CdeLumiere;           // Permet de slectionner une des quatre sortie de commande ddies  l'clairage
unsigned char Volume;               // Rglage du volume sonore de la carte SOMO14-D
unsigned char NumeroFichier;        // Numro du fichier  jouer (enregistr sur le carte micro SD place sur le module
                                    // somo14D
 //---------------------------------------------------------------------------------------------------------------------
// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
//---------------------------------------------------------------------------------------------------------------------
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=T State3=T State2=1 State1=1 State0=0 
PORTA=0x06; // Impratif pour que le reset du SOMO14-D et le premier rglage s'effectue correctement !!!!!!!!!!!!!!!
DDRA=0x07;
//---------------------------------------------------------------------------------------------------------------------
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=In Func1=Out Func0=Out 
// State7=T State6=T State5=0 State4=T State3=0 State2=T State1=0 State0=0 
PORTB=0x00; 
DDRB=0x2B;
//---------------------------------------------------------------------------------------------------------------------
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: 8bit top=FFh
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0H=0x00;
TCNT0L=0x00;
OCR0A=0x00;
OCR0B=0x00;
//---------------------------------------------------------------------------------------------------------------------
// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 62,500 kHz
// Mode: Ph. & fr. cor. PWM top=OCR1C
// OC1A output: OC1A=0
// OC1B output: OC1B=0
// OC1C output: OC1D=0
// Fault Protection Mode: Off
// Fault Protection Noise Canceler: Off
// Fault Protection triggered on Falling edge
// Fault Protection triggered by the Analog Comparator: Off
// Dead Time Rising Edge: 0,000 us
// Dead Time Falling Edge: 0,000 us
// Timer1 Overflow Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare D Match Interrupt: Off
// Fault Protection Interrupt: Off
PLLCSR=0x00;

TCCR1A=0xA3;      // PB avec Wizard: 0xC3 gnr au lieu de 0xA3
TCCR1B=0x08;      // 0k
TCCR1C=0xA9;      // PB avec Wizard: 0xC1 gnr au lieu de 0xA9
TCCR1D=0x01;      // ok
TCCR1E=0x00;
TC1H=0x00;
TCNT1=0x00;
TC1H=0x00;
OCR1A=0x00;
TC1H=0x00;
OCR1B=0x00;
TC1H=0x00;
OCR1C=0xFF;
TC1H=0x00;
OCR1D=0x00;
DT1=0x00;
//---------------------------------------------------------------------------------------------------------------------
// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: Off
// Interrupt on any change on pins PCINT0-7, 12-15: Off
// Interrupt on any change on pins PCINT8-11: Off
MCUCR=0x02;
GIMSK=0x40;
GIFR=0x40;
//---------------------------------------------------------------------------------------------------------------------
// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;
//---------------------------------------------------------------------------------------------------------------------
// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
USICR=0x00;
//---------------------------------------------------------------------------------------------------------------------
// Analog Comparator initialization
// Analog Comparator: Off
ACSRA=0x80;
// Hysterezis level: 0 mV
ACSRB=0x00;
//---------------------------------------------------------------------------------------------------------------------
// Global enable interrupts
#asm("sei")
//---------------------------------------------------------------------------------------------------------------------
// Initialisation du module SOMO14D
//---------------------------------------------------------------------------------------------------------------------
InitSOMO14D();                      // Mise  1 de Reset et CLK + squence de reset
Somo14DReglageVolume(VolumeINIT);   // Initialis  50%
SendFrameToSomo14D(0x0000);         // Lecture du premier fichier de la carte
//---------------------------------------------------------------------------------------------------------------------
while (1)
  {
     if (g_flag_char == VRAI)                                   // Rception d'un octet du SP d'interruption IRQ1
        {   // --------------------------------------------------------------------------------------------------------                                                    
         if ((g_Code_IBM & 0x80) == 0x80)                       // Test du b7 de g_Code_IBM 
                {                                               // si b7 = 1 => gestion de l'ECLAIRAGE
                    CdeLumiere = (g_Code_IBM & 0b01100000)>> 5;
                   
                    switch (CdeLumiere)                         // selon b6b5 de g_Code_IBM
                     {
                        case 0 : PWMProjecteur = (g_Code_IBM & 0x1F)*8; break;
                        case 1 : PWMRuban = (g_Code_IBM & 0x1F)*8; break;
                        case 2 : PWMDome = (g_Code_IBM & 0x1F)*8; break;
                        case 3 : if ((g_Code_IBM & 0x1F) == 0x1F) TORLED = 1;
                                                else TORLED = 0;
                        break;
                     }     
                }
            // --------------------------------------------------------------------------------------------------------   
                else                                            // sinon b7 = 0 => gestion du SON
                {                                               // par le module somo14D
                 if ((g_Code_IBM & 0x7E) == 0x7E) 
                    SendFrameToSomo14D(0xFFFE);                 // Commande Play / Pause
                        else if ((g_Code_IBM & 0x7F) == 0x7F)
                                  SendFrameToSomo14D(0xFFFF);   // Commande Stop
                                  else
                                    {
                                      Volume = (g_Code_IBM & 0b01110000)>> 4; 
                                      Somo14DReglageVolume(Volume); // rglage Volume [0,7]
                                      delay_ms(20);
                                      NumeroFichier = (g_Code_IBM & 0b00001111);
                                      SendFrameToSomo14D(0x0000 | NumeroFichier); // N du fichier [0,13] 
                                    }
                } 
                            
         g_flag_char = FAUX;                 // Octet consomm
        }                 
  }
//---------------------------------------------------------------------------------------------------------------------
}
// ====================================================================================================================
