
;CodeVisionAVR C Compiler V2.04.8a Standard
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATtiny861
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 128 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny861
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E

	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x0A
	.EQU GPIOR1=0x0B
	.EQU GPIOR2=0x0C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x025F
	.EQU __DSTACK_SIZE=0x0080
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;GPIOR0-GPIOR2 INITIALIZATION VALUES
	.EQU __GPIOR0_INIT=0x00
	.EQU __GPIOR1_INIT=0x00
	.EQU __GPIOR2_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x2020003:
	.DB  0xB
_0x2060060:
	.DB  0x1
_0x2060000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  _bitcount_RX_S1010000000
	.DW  _0x2020003*2

	.DW  0x01
	.DW  __seed_G103
	.DW  _0x2060060*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	;__GPIOR1_INIT = __GPIOR0_INIT
	OUT  GPIOR1,R30
	;__GPIOR2_INIT = __GPIOR0_INIT
	OUT  GPIOR2,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.8a Standard
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : PPE DESIGN
;Version : 1
;Date    : 23/04/2011
;Author  : Philippe Mariano
;Company : Lyce Pierre Emile Martin
;Comments:
;Rception d'une trame IBM pour la commande
;de l'clairage et du son sur le robot suiveur de
;ligne. Emission d'une trame SOMO14-D.
;
;
;Chip type               : ATtiny861
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 128
;*****************************************************/
;
;#include <tiny861.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_mask=0x18
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x18
	.SET power_ctrl_reg=mcucr
	#endif
;
;//=====================================================================================================================
;// Bibliothques non gnres par Wizard ( rajouter manuellement)
;//---------------------------------------------------------------------------------------------------------------------
;#include <math.h>
;#include <delay.h>
;//---------------------------------------------------------------------------------------------------------------------
;// Ces fichiers d'en-tte et les bibliothques associes doivent tre placs dans le rpertoire du projet
;//---------------------------------------------------------------------------------------------------------------------
;#include "TrameIBM.h"       // Sous-programme de dsrialisation et de dcodage de la
;			                // trame issue de la carte SISI
;#include "SOMO14D.h"        // Contient les fonctions permettant de commander le module SOMO14D
;//=====================================================================================================================
;
;//=====================================================================================================================
;// Dfinitions
;//---------------------------------------------------------------------------------------------------------------------
;// Boolens
;//---------------------------------------------------------------------------------------------------------------------
;#define VRAI                1
;#define FAUX                0
;//---------------------------------------------------------------------------------------------------------------------
;// Timers
;//---------------------------------------------------------------------------------------------------------------------
;#define PWMProjecteur       OCR1B
;#define PWMRuban            OCR1A
;#define PWMDome             OCR1D
;//---------------------------------------------------------------------------------------------------------------------
;// Sortie TOR
;//---------------------------------------------------------------------------------------------------------------------
;#define TORLED              PORTB.0
;//---------------------------------------------------------------------------------------------------------------------
;// Dclaration pour le module SOMO14-D
;//---------------------------------------------------------------------------------------------------------------------
;#define VolumeINIT          7           // Valeur initiale de l'incrment du volume (0  7)
;//=====================================================================================================================
;
;//=====================================================================================================================
;// Declare your global variables here
;//---------------------------------------------------------------------------------------------------------------------
;// type 		    nom 				       		dsignation
;//---------------------------------------------------------------------------------------------------------------------
;/* Communication avec le clavier PS2
;//---------------------------------------------------------------------------------------------------------------------
;Le programme principal se synchronise avec la routine d'interruption ext_int0_isr(void) situe dans la bibliothque
;"TrameIBM.lib" grce aux variables ci-dessous (voir le fichier d'en-tte TrameIBM.h)
;---------------------------------------------------------------------------------------------------------------------*/
;unsigned char g_Code_IBM = 0;           // Caractre extrait de la trame transmise par le clavier
;
;bit g_flag_char = FAUX;			        // g_flag_char = 1 lorsqu'une touche est appuye
;					                    // g_flag_char = 0 lorsqu'une touche a t relche
;unsigned int g_Trame_TX;                // Contient la valeur  envoyer au clavier
;//=====================================================================================================================
;
;//=====================================================================================================================
;//=====================================================================================================================
;// Programme principal
;//---------------------------------------------------------------------------------------------------------------------
;void main(void)
; 0000 0056 {

	.CSEG
_main:
; 0000 0057 // Declare your local variables here
; 0000 0058 //---------------------------------------------------------------------------------------------------------------------
; 0000 0059 unsigned char CdeLumiere;           // Permet de slectionner une des quatre sortie de commande ddies  l'clairage
; 0000 005A unsigned char Volume;               // Rglage du volume sonore de la carte SOMO14-D
; 0000 005B unsigned char NumeroFichier;        // Numro du fichier  jouer (enregistr sur le carte micro SD place sur le module
; 0000 005C                                     // somo14D
; 0000 005D  //---------------------------------------------------------------------------------------------------------------------
; 0000 005E // Crystal Oscillator division factor: 1
; 0000 005F #pragma optsize-
; 0000 0060 CLKPR=0x80;
;	CdeLumiere -> R17
;	Volume -> R16
;	NumeroFichier -> R19
	LDI  R30,LOW(128)
	OUT  0x28,R30
; 0000 0061 CLKPR=0x00;
	LDI  R30,LOW(0)
	OUT  0x28,R30
; 0000 0062 #ifdef _OPTIMIZE_SIZE_
; 0000 0063 #pragma optsize+
; 0000 0064 #endif
; 0000 0065 //---------------------------------------------------------------------------------------------------------------------
; 0000 0066 // Input/Output Ports initialization
; 0000 0067 // Port A initialization
; 0000 0068 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out
; 0000 0069 // State7=T State6=T State5=T State4=T State3=T State2=1 State1=1 State0=0
; 0000 006A PORTA=0x06; // Impratif pour que le reset du SOMO14-D et le premier rglage s'effectue correctement !!!!!!!!!!!!!!!
	LDI  R30,LOW(6)
	OUT  0x1B,R30
; 0000 006B DDRA=0x07;
	LDI  R30,LOW(7)
	OUT  0x1A,R30
; 0000 006C //---------------------------------------------------------------------------------------------------------------------
; 0000 006D // Port B initialization
; 0000 006E // Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=In Func1=Out Func0=Out
; 0000 006F // State7=T State6=T State5=0 State4=T State3=0 State2=T State1=0 State0=0
; 0000 0070 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0071 DDRB=0x2B;
	LDI  R30,LOW(43)
	OUT  0x17,R30
; 0000 0072 //---------------------------------------------------------------------------------------------------------------------
; 0000 0073 // Timer/Counter 0 initialization
; 0000 0074 // Clock source: System Clock
; 0000 0075 // Clock value: Timer 0 Stopped
; 0000 0076 // Mode: 8bit top=FFh
; 0000 0077 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 0078 TCCR0B=0x00;
	OUT  0x33,R30
; 0000 0079 TCNT0H=0x00;
	OUT  0x14,R30
; 0000 007A TCNT0L=0x00;
	OUT  0x32,R30
; 0000 007B OCR0A=0x00;
	OUT  0x13,R30
; 0000 007C OCR0B=0x00;
	OUT  0x12,R30
; 0000 007D //---------------------------------------------------------------------------------------------------------------------
; 0000 007E // Timer/Counter 1 initialization
; 0000 007F // Clock source: System Clock
; 0000 0080 // Clock value: 62,500 kHz
; 0000 0081 // Mode: Ph. & fr. cor. PWM top=OCR1C
; 0000 0082 // OC1A output: OC1A=0
; 0000 0083 // OC1B output: OC1B=0
; 0000 0084 // OC1C output: OC1D=0
; 0000 0085 // Fault Protection Mode: Off
; 0000 0086 // Fault Protection Noise Canceler: Off
; 0000 0087 // Fault Protection triggered on Falling edge
; 0000 0088 // Fault Protection triggered by the Analog Comparator: Off
; 0000 0089 // Dead Time Rising Edge: 0,000 us
; 0000 008A // Dead Time Falling Edge: 0,000 us
; 0000 008B // Timer1 Overflow Interrupt: Off
; 0000 008C // Compare A Match Interrupt: Off
; 0000 008D // Compare B Match Interrupt: Off
; 0000 008E // Compare D Match Interrupt: Off
; 0000 008F // Fault Protection Interrupt: Off
; 0000 0090 PLLCSR=0x00;
	OUT  0x29,R30
; 0000 0091 
; 0000 0092 TCCR1A=0xA3;      // PB avec Wizard: 0xC3 gnr au lieu de 0xA3
	LDI  R30,LOW(163)
	OUT  0x30,R30
; 0000 0093 TCCR1B=0x08;      // 0k
	LDI  R30,LOW(8)
	OUT  0x2F,R30
; 0000 0094 TCCR1C=0xA9;      // PB avec Wizard: 0xC1 gnr au lieu de 0xA9
	LDI  R30,LOW(169)
	OUT  0x27,R30
; 0000 0095 TCCR1D=0x01;      // ok
	LDI  R30,LOW(1)
	OUT  0x26,R30
; 0000 0096 TCCR1E=0x00;
	LDI  R30,LOW(0)
	OUT  0x0,R30
; 0000 0097 TC1H=0x00;
	RCALL SUBOPT_0x0
; 0000 0098 TCNT1=0x00;
	OUT  0x2E,R30
; 0000 0099 TC1H=0x00;
	RCALL SUBOPT_0x0
; 0000 009A OCR1A=0x00;
	OUT  0x2D,R30
; 0000 009B TC1H=0x00;
	RCALL SUBOPT_0x0
; 0000 009C OCR1B=0x00;
	OUT  0x2C,R30
; 0000 009D TC1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x25,R30
; 0000 009E OCR1C=0xFF;
	LDI  R30,LOW(255)
	OUT  0x2B,R30
; 0000 009F TC1H=0x00;
	RCALL SUBOPT_0x0
; 0000 00A0 OCR1D=0x00;
	OUT  0x2A,R30
; 0000 00A1 DT1=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 00A2 //---------------------------------------------------------------------------------------------------------------------
; 0000 00A3 // External Interrupt(s) initialization
; 0000 00A4 // INT0: On
; 0000 00A5 // INT0 Mode: Falling Edge
; 0000 00A6 // INT1: Off
; 0000 00A7 // Interrupt on any change on pins PCINT0-7, 12-15: Off
; 0000 00A8 // Interrupt on any change on pins PCINT8-11: Off
; 0000 00A9 MCUCR=0x02;
	LDI  R30,LOW(2)
	OUT  0x35,R30
; 0000 00AA GIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x3B,R30
; 0000 00AB GIFR=0x40;
	OUT  0x3A,R30
; 0000 00AC //---------------------------------------------------------------------------------------------------------------------
; 0000 00AD // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00AE TIMSK=0x00;
	LDI  R30,LOW(0)
	OUT  0x39,R30
; 0000 00AF //---------------------------------------------------------------------------------------------------------------------
; 0000 00B0 // Universal Serial Interface initialization
; 0000 00B1 // Mode: Disabled
; 0000 00B2 // Clock source: Register & Counter=no clk.
; 0000 00B3 // USI Counter Overflow Interrupt: Off
; 0000 00B4 USICR=0x00;
	OUT  0xD,R30
; 0000 00B5 //---------------------------------------------------------------------------------------------------------------------
; 0000 00B6 // Analog Comparator initialization
; 0000 00B7 // Analog Comparator: Off
; 0000 00B8 ACSRA=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00B9 // Hysterezis level: 0 mV
; 0000 00BA ACSRB=0x00;
	LDI  R30,LOW(0)
	OUT  0x9,R30
; 0000 00BB //---------------------------------------------------------------------------------------------------------------------
; 0000 00BC // Global enable interrupts
; 0000 00BD #asm("sei")
	sei
; 0000 00BE //---------------------------------------------------------------------------------------------------------------------
; 0000 00BF // Initialisation du module SOMO14D
; 0000 00C0 //---------------------------------------------------------------------------------------------------------------------
; 0000 00C1 InitSOMO14D();                      // Mise  1 de Reset et CLK + squence de reset
	RCALL _InitSOMO14D
; 0000 00C2 Somo14DReglageVolume(VolumeINIT);   // Initialis  50%
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _Somo14DReglageVolume
; 0000 00C3 SendFrameToSomo14D(0x0000);         // Lecture du premier fichier de la carte
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x1
	RCALL _SendFrameToSomo14D
; 0000 00C4 //---------------------------------------------------------------------------------------------------------------------
; 0000 00C5 while (1)
_0x3:
; 0000 00C6   {
; 0000 00C7      if (g_flag_char == VRAI)                                   // Rception d'un octet du SP d'interruption IRQ1
	SBIS 0xA,0
	RJMP _0x6
; 0000 00C8         {   // --------------------------------------------------------------------------------------------------------
; 0000 00C9          if ((g_Code_IBM & 0x80) == 0x80)                       // Test du b7 de g_Code_IBM
	RCALL SUBOPT_0x2
	ANDI R30,LOW(0x80)
	CPI  R30,LOW(0x80)
	BRNE _0x7
; 0000 00CA                 {                                               // si b7 = 1 => gestion de l'ECLAIRAGE
; 0000 00CB                     CdeLumiere = (g_Code_IBM & 0b01100000)>> 5;
	RCALL SUBOPT_0x2
	ANDI R30,LOW(0x60)
	RCALL SUBOPT_0x3
	ASR  R31
	ROR  R30
	RCALL __ASRW4
	MOV  R17,R30
; 0000 00CC 
; 0000 00CD                     switch (CdeLumiere)                         // selon b6b5 de g_Code_IBM
	MOV  R30,R17
	RCALL SUBOPT_0x3
; 0000 00CE                      {
; 0000 00CF                         case 0 : PWMProjecteur = (g_Code_IBM & 0x1F)*8; break;
	SBIW R30,0
	BRNE _0xB
	RCALL SUBOPT_0x4
	OUT  0x2C,R30
	RJMP _0xA
; 0000 00D0                         case 1 : PWMRuban = (g_Code_IBM & 0x1F)*8; break;
_0xB:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xC
	RCALL SUBOPT_0x4
	OUT  0x2D,R30
	RJMP _0xA
; 0000 00D1                         case 2 : PWMDome = (g_Code_IBM & 0x1F)*8; break;
_0xC:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0xD
	RCALL SUBOPT_0x4
	OUT  0x2A,R30
	RJMP _0xA
; 0000 00D2                         case 3 : if ((g_Code_IBM & 0x1F) == 0x1F) TORLED = 1;
_0xD:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0xA
	RCALL SUBOPT_0x2
	ANDI R30,LOW(0x1F)
	CPI  R30,LOW(0x1F)
	BRNE _0xF
	SBI  0x18,0
; 0000 00D3                                                 else TORLED = 0;
	RJMP _0x12
_0xF:
	CBI  0x18,0
; 0000 00D4                         break;
_0x12:
; 0000 00D5                      }
_0xA:
; 0000 00D6                 }
; 0000 00D7             // --------------------------------------------------------------------------------------------------------
; 0000 00D8                 else                                            // sinon b7 = 0 => gestion du SON
	RJMP _0x15
_0x7:
; 0000 00D9                 {                                               // par le module somo14D
; 0000 00DA                  if ((g_Code_IBM & 0x7E) == 0x7E)
	RCALL SUBOPT_0x2
	ANDI R30,LOW(0x7E)
	CPI  R30,LOW(0x7E)
	BRNE _0x16
; 0000 00DB                     SendFrameToSomo14D(0xFFFE);                 // Commande Play / Pause
	LDI  R30,LOW(65534)
	LDI  R31,HIGH(65534)
	RJMP _0x1D
; 0000 00DC                         else if ((g_Code_IBM & 0x7F) == 0x7F)
_0x16:
	RCALL SUBOPT_0x2
	ANDI R30,0x7F
	CPI  R30,LOW(0x7F)
	BRNE _0x18
; 0000 00DD                                   SendFrameToSomo14D(0xFFFF);   // Commande Stop
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x1D
; 0000 00DE                                   else
_0x18:
; 0000 00DF                                     {
; 0000 00E0                                       Volume = (g_Code_IBM & 0b01110000)>> 4;
	RCALL SUBOPT_0x2
	ANDI R30,LOW(0x70)
	RCALL SUBOPT_0x3
	RCALL __ASRW4
	MOV  R16,R30
; 0000 00E1                                       Somo14DReglageVolume(Volume); // rglage Volume [0,7]
	ST   -Y,R16
	RCALL _Somo14DReglageVolume
; 0000 00E2                                       delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RCALL SUBOPT_0x5
; 0000 00E3                                       NumeroFichier = (g_Code_IBM & 0b00001111);
	RCALL SUBOPT_0x2
	ANDI R30,LOW(0xF)
	MOV  R19,R30
; 0000 00E4                                       SendFrameToSomo14D(0x0000 | NumeroFichier); // N du fichier [0,13]
	MOV  R30,R19
	RCALL SUBOPT_0x3
_0x1D:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _SendFrameToSomo14D
; 0000 00E5                                     }
; 0000 00E6                 }
_0x15:
; 0000 00E7 
; 0000 00E8          g_flag_char = FAUX;                 // Octet consomm
	CBI  0xA,0
; 0000 00E9         }
; 0000 00EA   }
_0x6:
	RJMP _0x3
; 0000 00EB //---------------------------------------------------------------------------------------------------------------------
; 0000 00EC }
_0x1C:
	RJMP _0x1C
;// ====================================================================================================================

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_ext_int0_isr:
	ST   -Y,R0
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30

	.DSEG

	.CSEG
	ST   -Y,R17
	LDS  R30,_edge_S1010000000
	CPI  R30,0
	BRNE _0x2020004
	LDS  R26,_bitcount_RX_S1010000000
	CPI  R26,LOW(0xC)
	BRSH _0x2020006
	CPI  R26,LOW(0x1)
	BRSH _0x2020007
_0x2020006:
	RJMP _0x2020005
_0x2020007:
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	SBIS 0x16,4
	RJMP _0x2020008
	__ORBMNN _g_data_S1010000000,1,128
_0x2020008:
_0x2020005:
	LDI  R30,LOW(3)
	OUT  0x35,R30
	LDI  R30,LOW(1)
	STS  _edge_S1010000000,R30
	RJMP _0x2020009
_0x2020004:
	LDI  R30,LOW(2)
	OUT  0x35,R30
	LDI  R30,LOW(0)
	STS  _edge_S1010000000,R30
	LDS  R30,_bitcount_RX_S1010000000
	SUBI R30,LOW(1)
	STS  _bitcount_RX_S1010000000,R30
	CPI  R30,0
	BRNE _0x202000A
	LDS  R26,_g_data_S1010000000
	LDS  R27,_g_data_S1010000000+1
	LDI  R30,LOW(5)
	RCALL __LSRW12
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x6
	STS  _g_data_aff_S1010000000,R30
	STS  _g_Code_IBM,R30
	SBIS 0xA,0
	SBI  0xA,0
	LDI  R30,LOW(11)
	STS  _bitcount_RX_S1010000000,R30
_0x202000A:
_0x2020009:
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R0,Y+
	RETI
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_InitSOMO14D:
	SBI  0x1B,2
	SBI  0x1B,1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x5
	RCALL _Somo14DReset
	RET
_Somo14DReset:
	CBI  0x1B,2
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x5
	SBI  0x1B,2
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x5
	RET
_Somo14DStart:
	CBI  0x1B,1
	RJMP _0x20C0001
_Somo14DStop:
	SBI  0x1B,1
_0x20C0001:
	__DELAY_USW 5000
	RET
_Somo14DTransfertInt:
	RCALL __SAVELOCR4
	LDI  R19,LOW(0)
_0x2040013:
	CPI  R19,16
	BRSH _0x2040014
	CBI  0x1B,1
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ANDI R30,LOW(0x8000)
	ANDI R31,HIGH(0x8000)
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x2040017
	CBI  0x1B,0
	RJMP _0x204001A
_0x2040017:
	SBI  0x1B,0
_0x204001A:
	RCALL SUBOPT_0x8
	SBI  0x1B,1
	RCALL SUBOPT_0x8
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	LSL  R30
	ROL  R31
	STD  Y+4,R30
	STD  Y+4+1,R31
	SUBI R19,-1
	RJMP _0x2040013
_0x2040014:
	RCALL __LOADLOCR4
	ADIW R28,6
	RET
_Somo14DReglageVolume:
	RCALL _Somo14DStart
	LD   R30,Y
	RCALL SUBOPT_0x3
	SUBI R30,LOW(-65520)
	SBCI R31,HIGH(-65520)
	RCALL SUBOPT_0x1
	RCALL _Somo14DTransfertInt
	RCALL _Somo14DStop
	ADIW R28,1
	RET
_SendFrameToSomo14D:
	RCALL _Somo14DStart
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x1
	RCALL _Somo14DTransfertInt
	RCALL _Somo14DStop
	ADIW R28,2
	RET

	.CSEG

	.DSEG

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_g_Code_IBM:
	.BYTE 0x1
_g_data_S1010000000:
	.BYTE 0x2
_g_data_aff_S1010000000:
	.BYTE 0x1
_edge_S1010000000:
	.BYTE 0x1
_bitcount_RX_S1010000000:
	.BYTE 0x1
__seed_G103:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	OUT  0x25,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2:
	LDS  R30,_g_Code_IBM
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x4:
	RCALL SUBOPT_0x2
	ANDI R30,LOW(0x1F)
	LSL  R30
	LSL  R30
	LSL  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	RCALL SUBOPT_0x1
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6:
	LDS  R30,_g_data_S1010000000
	LDS  R31,_g_data_S1010000000+1
	LSR  R31
	ROR  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	STS  _g_data_S1010000000,R30
	STS  _g_data_S1010000000+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	__DELAY_USW 300
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
